"""Search functions

Revision ID: a803745f7840
Revises: 5ffc4e562ed8
Create Date: 2023-06-27 23:10:06.088917

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'a803745f7840'
down_revision = '5ffc4e562ed8'
branch_labels = None
depends_on = None


def upgrade():
    op.execute("""CREATE FUNCTION websearch_to_tsquery_multilang(text) RETURNS tsquery AS $$
SELECT websearch_to_tsquery('french', $1) ||
        websearch_to_tsquery('english', $1) ||
        websearch_to_tsquery('simple', $1)
$$ LANGUAGE sql IMMUTABLE;""")
    op.execute("""CREATE FUNCTION to_tsvector_multilang(text) RETURNS tsvector AS $$
SELECT to_tsvector('french', $1) ||
        to_tsvector('english', $1) ||
        to_tsvector('simple', $1)
$$ LANGUAGE sql IMMUTABLE;""")


def downgrade():
    op.execute("DROP FUNCTION websearch_to_tsquery_multilang(text);")
    op.execute("DROP FUNCTION to_tsvector_multilang(text);")
